
;Ascii-T 82
;Par Kaid [kaid@excite.fr]         

.INCLUDE CRASH82.INC
.DB "AT-82",0

; - Code ASCII des "flches" -

F_GAUCHE = 207
F_DROITE = 216
F_HAUT   = 6
F_BAS    = 7

; - Initialisation -

        CALL CLEARLCD           ;Efface l'cran texte

        LD HL,Data              ;Pointe sur 'data'
        LD DE,0001              ;Position initiale (0,1)
        LD B,7                  ;Nombre de chaines  afficher

Aff_Str:
        LD (CURSOR_POS),DE      ;Place le curseur

        CALL D_ZT_STR           ;Affiche la chaine

        INC DE                  ;Pour passer  la ligne suivante         

        DJNZ Aff_Str            ;Boucle pour afficher toutes les chaines



        LD B,0                  ;B=0. B contient le code


; - Boucle principale -

Boucle:

        LD HL,$0501             ;Affiche le code ASCII
        LD (CURSOR_POS),HL
        LD L,B
        LD H,0                  ;HL=B
        CALL D_HL_DECI          


        LD HL,$0803             ;Affiche le caractre correspondant
        LD (CURSOR_POS),HL
        LD A,B
        CALL TX_CHARPUT         ;On affiche le caractre

        PUSH BC                 ;On sauve BC  cause de CR_KHAND
        CALL CR_KHAND           ;Attend la pression d'une touche
        POP BC

        CP K_MODE               ;[MODE] presse ?
        RET Z

        LD C,0                  ;C=Limite suprieure

        CP K_UP                 ;Flche haut presse ?
        JR Z,IncCar 

        CP K_RIGHT              ;Flche droite presse ?
        JR Z,I10Car 

        LD C,225                ;C=Limite infrieure

        CP K_DOWN               ;Flche bas presse ?
        JR Z,DecCar  

        CP K_LEFT               ;Flche gauche presse ?
        JR Z,D10Car             


        JR Boucle               ;On boucle car la touche n'est pas traite


; - Le code est dcrment -
DecCar:
        DEC B                   ;Dcremente le code
        JR Test_ASCII_Code      ;Va  'Test_ASCII_Code'        

; - Le code est incrment -
IncCar:
        INC B                   ;Incrmente le code
        JR Test_ASCII_Code      ;Va  'Test_ASCII_Code'


; - Le code est dcrment de 10 -
D10Car:
        
        LD A,B
        SUB 10                  ;Soustrait 10 au code
        LD B,A

        JR Test_ASCII_Code      ;Va  'Test_ASCII_Code'

; - Le code est incrment de 10 -
I10Car:
        LD A,B
        ADD A,10                ;Ajoute 10 au code
        LD B,A



; - On va tester si le code n'est pas suprieur  225. Si c'est le cas, on
;   le remplace par C, borne suprieure ou infrieure -

Test_ASCII_Code:

        LD A,B                  ;A=Code
        CP 225                  ;On test si le code est infrieur  225
        JR C,Boucle             ;Si oui, c'est ok, le code ne dpasse pas 225

        LD B,C                  ;B contient maintenant la limite inf/sup
        JR Boucle               ;On boucle


; - Lgende -
Data .DB "Code:",0
     .DB 0   
     .DB "Car :",0
     .DW 0  
     .DB "   ",F_BAS,  " -1  +1 ",F_HAUT,0
     .dB "  ",F_GAUCHE," -10  +10 ",F_DROITE,0
